{$WARN UNIT_PLATFORM OFF}
{$WARN SYMBOL_PLATFORM OFF}
{$WARN SYMBOL_DEPRECATED OFF}

unit pMainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, resample, Jpeg, ShellAPI, math, NkDib, ShlObj,
  FolderDialog, ComObj, ActiveX, ComCtrls, Buttons, INIFiles;

type
  TAddPageEvent  = procedure(path,fname:String) of object;
  TWidePageEvent = procedure(pages:Integer) of object;

  TConvertThread = class(TThread)
  private
    { Private 錾 }
    SaveFname: String;
    procedure WidePageEvent;
    procedure SaveBmp;
  public
    OrgJpg   : TJpegImage;
    SavBmp   : TBitmap;
    Fname    : String;
    FPath    : String;
    Filter   : Integer;
    AddPage  : TAddPageEvent;
    WidePage : TWidePageEvent;
    Pages    : Integer;
  protected
    procedure Execute; override;
  end;

  TWatchOpenDialogThread = class(TThread)
  private
    { Private 錾 }
  public
    BasehWnd : Integer;
    PostPath : String;
    PostFile : String;
  protected
    procedure Execute; override;
  end;

  TWatchCreateDialogThread = class(TThread)
  private
    { Private 錾 }
  public
    BasehWnd  : Integer;
    WatchStr  : String;
    ButtonStr : String;
    WaitTime  : Integer;
  protected
    procedure Execute; override;
  end;

  TMangaSigmaForm = class(TForm)
    FileList: TListBox;
    Label1: TLabel;
    FolderDlg1: TFolderDlg;
    MainTimer: TTimer;
    RemainLabel: TLabel;
    GroupBox1: TGroupBox;
    StartButton: TSpeedButton;
    StopButton: TSpeedButton;
    ConvertingFileLabel: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure MainTimerTimer(Sender: TObject);
    procedure FileListDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure ConvThreadFinish(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private 錾 }
    ConvThread   :TConvertThread;
    FilterType   :Integer;
    NowFolder    :String;
    OutputFolder :String;
    DeleteFiles  :TStringList;
    BuildPages   :TStringList;
    LastWidePage :Integer;
    PageNumber   :Integer;
    BlankNumber  : Integer;
    procedure WMDropFiles(var Msg: TWMDROPFILES); message WM_DROPFILES;
    procedure AddItem(name: String);
    procedure ConvertFirstItem;
    procedure UpdateRemains;
    function  CheckBuilder: Boolean;
    procedure AddPageToBuilder(path,name: String);
    procedure WidePageDetected(pages: Integer);
    procedure BuildBook;
    procedure DeleteTemporaryFiles;
    procedure SaveBlankBmp(path,name: String; page:Integer);
  public
    { Public 錾 }
  end;

var
  MangaSigmaForm: TMangaSigmaForm;

implementation

{$R *.dfm}

// EChE֐------------------------------------------------------------------

function FindButton(hWnd:Integer; var parent:Integer; str:String):Integer;
var
  hw: Integer;
  pc: Array [0..1023] of Char;
  pc2: String;
begin
  hw  := 0;
  Result := 0;
  repeat
    hw := FindWindowEx(hWnd,hw,nil,nil);
    if (hw<>0) then
    begin
      GetWindowText(hw,pc,1024);
      pc2 := String(pc);
      if (str = pc2) then
      begin
        Result := hw;
        parent := hWnd;
        hw := 0;
      end
        else
      begin
        Result := FindButton(hw,parent,str);
      end;
    end;
  until ((hw=0) or (Result<>0));
end;

procedure SendText(hWnd:Integer; str:String);
var
  i: Integer;
begin
  for i:=1 to Length(str) do
  begin
    SendMessage(hWnd,WM_CHAR,Integer(ord(str[i])),0);
  end;
end;

procedure PushButton(hWnd:Integer);
begin
  SendMessage(hWnd,WM_LBUTTONUP,0,0);
  SendMessage(hWnd,BM_CLICK,0,0);
end;


// ------------------------- Subroutine

function TemporaryPath: String;
var
  lpPathBuffer : PChar;
begin
  GetMem(lpPathBuffer, MAX_PATH);
  GetTempPath(MAX_PATH, lpPathBuffer);
  Result := StrPas(lpPathBuffer);
  FreeMem(lpPathBuffer, MAX_PATH);
end;

function GetTempName: String;
var
  s: String;
  i: Integer;
begin
  s := '';
  for i:=0 to 3 do
  begin
    s := s + IntToHex(Random(65536),4)+IntToHex(Random(65536),4);
    if (i<>3) then s := s + '-';
  end;
  result := s;
end;

function GetDesktopFolder: string;

  function GetDispName(shi: IShellFolder; pidl: PItemIDList): string;
  var DispName: TStrRet;
  begin
    shi.GetDisplayNameOf(pidl, SHGDN_FORPARSING, DispName);

    if DispName.uType = STRRET_CSTR then
      Result := DispName.cStr
    else if DispName.uType = STRRET_OFFSET then
      Result := PCHAR(LongInt(pidl) + LongInt(DispName.uOffset))
    else
      Result := WideCharToString(DispName.pOleStr);
  end;

  var Pidl: PItemIDList;
      DesktopFolderI: IShellFolder;

begin
  OleCheck(SHGetSpecialFolderLocation(0, CSIDL_DESKTOPDIRECTORY, Pidl));
  try
    OleCheck(SHGetDesktopFolder(DesktopFolderI));
    Result := GetDispName(DesktopFolderI, Pidl);
  finally
    CoTaskMemFree(Pidl);
  end;
end;




// ------------------------- ConvertThread

procedure TConvertThread.SaveBmp;
begin
  try
    SavBmp.SaveToFile(FPath+SaveFname);
    AddPage(FPath,SaveFname);
  except
  end;
end;

procedure TConvertThread.WidePageEvent;
begin
  WidePage(Pages);
end;

procedure TConvertThread.Execute;
var
  w,h,x,y: Integer;
  pag,i,j,x0,xs,m: Integer;
  OrgBmp,TgtBmp: TBitmap;
  Org,Tgt: TNkDib;
  c:TColor; { (msb)00 rr gg bb(lsb) }
  rgb:array[0..3] of byte absolute c;
begin
  Org    := TNkDib.Create;
  Tgt    := TNkDib.Create;
  OrgBmp := TBitmap.Create;
  TgtBmp := TBitmap.Create;
  try
    OrgBmp.Assign(OrgJpg);

    // 1008+16 x 768
    if (OrgJpg.Height = 0) or (OrgJpg.Width = 0) then exit;

    // ɕvZ
    h := 1008;
    w := Floor(OrgJpg.Width  * (h / OrgJpg.Height));
    if ((w mod 2)=1) then w := w + 1;
    if ((h mod 2)=1) then h := h + 1;

    // ܂̓TCY
    TgtBmp.Width  := w;
    TgtBmp.Height := h;
    Stretch(OrgBmp, TgtBmp, ResampleFilters[5].Filter, ResampleFilters[5].Width);
    Org.Assign(TgtBmp);  // Org...IWiTCY(c1008)

    // y[W\̌
    pag := (w div 768) + 1;
    if ( (w-((pag-1)*768)) < 384 ) then pag := pag - 1;
    xs := (w - (768 * pag)) div 2;

    // J
    if (pag > 1) then
    begin
      Pages := pag;
      Synchronize(WidePageEvent);
    end;
  
    // ؂oȂۑ
    for i:=1 to pag do
    begin
      x0 := xs + (pag - i)*768;
      Tgt.Width  := 768;
      Tgt.Height := 1024;
      Tgt.PixelFormat := nkPf4bit;
      Tgt.PaletteSize := 16;
      for j:=0 to 15 do
      begin
        Tgt.Colors[j] := ((j*17) shl 16)+((j*17) shl 8)+(j*17);
      end;

      // ؂o
      for y:=0 to 1007 do
      begin
        for x:=0 to 767 do
        begin
          if (((x+x0)>=0) and ((x+x0)<w)) then
          begin
            c := Org.Pixels[x+x0,y];
            m := (rgb[2]*30 + rgb[1]*59 + rgb[0]*11 + 50) div 1700;
            if (m>15) then m:=15;
            Tgt.Pixels[x,y] := m;
          end
            else
          begin
            Tgt.Pixels[x,y] := 15;
          end;
        end;
      end;
      for y:=1008 to 1023 do
      begin
        for x:=0 to 767 do
        begin
          Tgt.Pixels[x,y] := 15;
        end;
      end;

      // ۑ
      SavBmp.Assign(Tgt);
      if (pag = 1) then
      begin
        SaveFname := FName+'.bmp';
      end
        else
      begin
        SaveFname := FName+'-'+IntToStr(i)+'.bmp';
      end;
      Synchronize(SaveBmp);
    end;
  finally
    TgtBmp.Free;
    OrgBmp.Free;
    Tgt.Free;
    Org.Free;
  end;
end;


// Open DialogXbh-------------------------------------------------------------

procedure TWatchOpenDialogThread.Execute;
var
  tim: Integer;
  hWnd_P,hWnd_Open: Integer;
  hWnd_OK,hWnd_Cancel: Integer;
  hWnd_OpenText: Integer;
begin
  Sleep(200);

  tim       := 10;
  hWnd_Open := 0;
  while ((hWnd_Open<=0) and (tim>0)) do
  begin
    hWnd_P        := 0;
    hWnd_Open     := FindButton(0,hWnd_P,'t@CJ');
    if (hWnd_Open <= 0) then
    begin
      tim := tim - 1;
      Sleep(100);
    end;
  end;

  if (hWnd_Open > 0) then
  begin
    hWnd_OK       := FindButton(hWnd_Open,hWnd_P,'J(&O)');
    hWnd_Cancel   := FindButton(hWnd_Open,hWnd_P,'LZ');
    hWnd_OpenText := FindWindowEx(hWnd_P,0,'Edit',nil);
    if ((hWnd_OK <> 0) and (hWnd_Cancel <> 0) and (hWnd_OpenText <> 0)) then
    begin
      Sleep(50);
      SendText(hWnd_OpenText,PostPath);
      PushButton(hWnd_OK);
      Sleep(100);
      SendMessage(hWnd_OpenText,WM_CLEAR,0,0);
      SendText(hWnd_OpenText,PostFile);
      PushButton(hWnd_OK);
    end;
  end;
end;


// mFDialogXbh--------------------------------------------------------------

procedure TWatchCreateDialogThread.Execute;
var
  tim: Integer;
  hWnd_P,hWnd_Dialog: Integer;
  hWnd_OK: Integer;
begin
  Sleep(200);

  tim         := WaitTime;
  hWnd_Dialog := 0;
  while ((hWnd_Dialog<=0) and ((tim>0) or (WaitTime = 0))) do
  begin
    hWnd_P        := 0;
    hWnd_Dialog   := FindButton(0,hWnd_P,WatchStr);
    if (hWnd_Dialog <= 0) then
    begin
      if (WaitTime<>0) then tim := tim - 1;
      Sleep(100);
    end;
  end;

  if ((hWnd_Dialog > 0) and (hWnd_P > 0)) then
  begin
    hWnd_OK       := FindButton(hWnd_P,hWnd_Dialog,ButtonStr);
    if (hWnd_OK <> 0) then
    begin
      Sleep(200);
      PushButton(hWnd_OK);
    end;
  end;
end;

// ------------------------- MainForm

procedure TMangaSigmaForm.ConvThreadFinish(Sender: TObject);
begin
  ConvertingFileLabel.Caption := '';
  ConvThread.OrgJpg.Free;
  ConvThread.SavBmp.Free;
  ConvThread := nil;
  if (StartButton.Down) then
  begin
    ConvertFirstItem;
  end;
end;


procedure TMangaSigmaForm.AddPageToBuilder(path,name: String);
begin
  // y[WԍJEg
  PageNumber := PageNumber + 1;

  // 폜\񃊃Xg֒ǉ
  if Assigned(DeleteFiles) then DeleteFiles.Add(path+name);
  // \zt@CXg֒ǉ
  if Assigned(BuildPages)  then BuildPages.Add(name);
end;

procedure TMangaSigmaForm.SaveBlankBmp(path,name: String; page:Integer);
var
  Bmp: TNkDib;
  i,x,y: Integer;
begin
  Bmp := TNkDib.Create;
  try
    Bmp.Width  := 768;
    Bmp.Height := 1024;
    Bmp.PixelFormat := nkPf4bit;
    Bmp.PaletteSize := 16;
    for i:=0 to 15 do
    begin
      Bmp.Colors[i] := ((i*17) shl 16)+((i*17) shl 8)+(i*17);
    end;
    for y:=0 to 1023 do
    begin
      for x:=0 to 767 do
      begin
        Bmp.Pixels[x,y] := 15;
      end;
    end;
    Bmp.SaveToFile(path+name);
    // 폜\񃊃Xg֒ǉ
    if Assigned(DeleteFiles) then DeleteFiles.Add(path+name);
    // \zt@CXg֒ǉ
    if Assigned(BuildPages)  then BuildPages.Insert(page,name);
  finally
    Bmp.Free;
  end;
end;

procedure TMangaSigmaForm.WidePageDetected(pages: Integer);
var
  path,name: String;
begin
  // AddPageToBuildeȓOɌĂяo
  if ((PageNumber mod 2)<>(pages mod 2)) then
  begin
    // JsI
    path := IncludeTrailingPathDelimiter(OutputFolder);
    name := 'SBMblnk'+IntToStr(BlankNumber+1)+'.bmp';
    BlankNumber := BlankNumber + 1;

    if ((pages mod 2)=0) then
    begin
      // Jy[WcŌ̌Jy[WBlank}
      SaveBlankBmp(path,name,LastWidePage);
      PageNumber := PageNumber + 1;
    end
      else
    begin
      // Jy[Wc̃y[WBlank}
      SaveBlankBmp(path,name,PageNumber);
      PageNumber := PageNumber + 1;
    end;
  end;
  LastWidePage := PageNumber + pages;
end;

procedure TMangaSigmaForm.ConvertFirstItem;
var
  name: String;
  path,spath: String;
begin
  if ((ConvThread = nil) and (FileList.Items.Count > 0)) then
  begin
    name := FileList.Items[0];
    FileList.Items.Delete(0);
    UpdateRemains;
    path  := ExcludeTrailingPathDelimiter(ExtractFilePath(name));
    path  := IncludeTrailingPathDelimiter(ExtractFileName(path));
    spath := path;
    path  := IncludeTrailingPathDelimiter(OutputFolder);

    // iύXH
    if ((spath <> NowFolder) and (NowFolder <> '')) then
    begin
      BuildBook;
      PageNumber   := 0;
      BlankNumber  := 0;
      LastWidePage := 0;
      NowFolder := '';
    end;
    NowFolder := spath;

    //
    ConvThread := TConvertThread.Create(True);
    with ConvThread do
    begin
      FreeOnTerminate := True;
      OnTerminate     := ConvThreadFinish;
      OrgJpg          := TJpegImage.Create;
      SavBmp          := TBitmap.Create;
      FPath           := path;
      FName           := ChangeFileExt(ExtractFileName(name),'');
      Filter          := FilterType;
      AddPage         := AddPageToBuilder;
      WidePage        := WidePageDetected;
      ConvertingFileLabel.Caption := spath+ExtractFileName(name);
    end;

    try
      ForceDirectories(path);
      ConvThread.OrgJpg.LoadFromFile(name);
      ConvThread.Resume;
    except
      ConvThread.SavBmp.Free;
      ConvThread.OrgJpg.Free;
      ConvThread.Free;
      ConvThread := nil;
    end;
  end
    else
  begin
    // IH
    if ((FileList.Items.Count = 0) and (ConvThread = nil) and (NowFolder <> '')) then
    begin
      BuildBook;
      PageNumber   := 0;
      BlankNumber  := 0;
      LastWidePage := 0;
      NowFolder := '';
    end;
  end;
end;

procedure TMangaSigmaForm.FormCreate(Sender: TObject);
var
  INI: TINIFile;
  i: Integer;
begin
  Randomize;
  if (not CheckBuilder) then
  begin
    Application.MessageBox('BookBuilderNAuIWiЁvuC[Wf[^vJĂsĂ','G[');
    Application.Terminate;
  end
    else
  begin
    ConvThread   := nil;
    DeleteFiles  := TStringList.Create;
    BuildPages   := TStringList.Create;
    NowFolder    := '';
    PageNumber   := 0;
    BlankNumber  := 0;
    LastWidePage := 0;
    OutputFolder := IncludeTrailingPathDelimiter(TemporaryPath)+GetTempName;
    MkDir(OutputFolder);
    FilterType   := 5;
    INI := TINIFile.Create(ChangeFileExt(Application.ExeName,'.ini'));
    try
      i := INI.ReadInteger('Config','ResampleFilter',5);
      if ((i>=0) and (i<=6)) then FilterType := i;
    finally
      INI.Free;
    end;

    DragAcceptFiles(Handle, True);
  end;
end;

procedure TMangaSigmaForm.AddItem(name: String);
var
  at: Integer;
  sr: TSearchRec;
begin
  at := FileGetAttr(name);
  if ((at and faDirectory)<>0) then
  begin
    // Directory
    if (DirectoryExists(name)) then
    begin
      if (FindFirst(IncludeTrailingPathDelimiter(name)+'*.*', faAnyFile, sr)=0) then
      begin
        repeat
          if ((sr.Name<>'.') and (sr.Name<>'..')) then
          begin
            AddItem(IncludeTrailingPathDelimiter(name)+sr.Name);
          end;
        until FindNext(sr)<>0;
        FindClose(sr);
      end;

    end;
  end
    else
  begin
    if (FileExists(name)) then
    begin
      // File
      if ((UpperCase(ExtractFileExt(name))='.JPG') or (UpperCase(ExtractFileExt(name))='.JPEG')) then
      begin
        FileList.Items.Add(name);
        UpdateRemains;
      end;
    end;
  end;
end;

// Book Builder֘A--------------------------------------------------------------
function TMangaSigmaForm.CheckBuilder:Boolean;
var
  hWnd,hWnd2,hWnd_P: Integer;
begin
  hWnd := FindWindow(nil,'BookBuilder');
  if (hWnd = 0) then
  begin
    Result := False;
  end
    else
  begin
    // EChE
    hWnd2 := FindButton(hWnd,hWnd_P,'Xgɒǉ');
    if (hWnd2<>0) then
    begin
      if (IsWindowVisible(hWnd2)) then
      begin
        Result := True;
      end
        else
      begin
        Result := False;
      end;
    end
      else
    begin
      Result := False;
    end;
  end;
end;

procedure TMangaSigmaForm.BuildBook;
var
  hWnd,hWnd_P    : Integer;
  hWnd_Build,hWnd_Clear,hWnd_Add,hWnd_Title,hWnd_Author,hWnd_Synop: Integer;
  OpenThread     : TWatchOpenDialogThread;
  DialogThread   : TWatchCreateDialogThread;
  CompleteThread : TWatchCreateDialogThread;
  i              : Integer;
  Files          : String;
begin
  hWnd := FindWindow(nil,'BookBuilder');
  if (hWnd <> 0) and (BuildPages.Count > 0) then
  begin
    // --------------------- i^Cg
    hWnd_P := 0;
    hWnd_Clear := FindButton(hWnd,hWnd_P,'NA');
    hWnd_Add   := FindButton(hWnd,hWnd_P,'Xgɒǉ');
    hWnd_Build := FindButton(hWnd,hWnd_P,'쐬');
    if ((hWnd_Build<>0) and (hWnd_P<>0)) then
    begin
      // EditBox
      hWnd_Title  := FindWindowEx(hWnd_P,          0,'Edit',nil);
      hWnd_Author := FindWindowEx(hWnd_P, hWnd_Title,'Edit',nil);
      hWnd_Synop  := FindWindowEx(hWnd_P,hWnd_Author,'Edit',nil);
      if ((hWnd_Title<>0) and (hWnd_Author<>0) and (hWnd_Synop<>0)) then
      begin
        // NA
        PushButton(hWnd_Clear);

        // ^CgAҐݒ
        SendText(hWnd_Title,ExcludeTrailingPathDelimiter(NowFolder));
        SendText(hWnd_Author,'MangaSigma');

        // ڒǉ
        Files := '';
        for i:=0 to BuildPages.Count-1 do
        begin
          if (Length(Files + '"' + BuildPages.Strings[i] + '" ')>250) then
          begin
            if (Files<>'') then
            begin
              OpenThread := TWatchOpenDialogThread.Create(True);
              OpenThread.FreeOnTerminate := True;
              OpenThread.BasehWnd := hWnd;
              OpenThread.PostPath := OutputFolder;
              OpenThread.PostFile := Files;
              OpenThread.Resume;
              PushButton(hWnd_Add);
            end;
            Files := '';
          end;
          Files := Files + '"' + BuildPages.Strings[i] + '" ';
        end;
        if (Files<>'') then
        begin
          OpenThread := TWatchOpenDialogThread.Create(True);
          OpenThread.FreeOnTerminate := True;
          OpenThread.BasehWnd := hWnd;
          OpenThread.PostPath := OutputFolder;
          OpenThread.PostFile := Files;
          OpenThread.Resume;
          PushButton(hWnd_Add);
        end;

        // 쐬
        DialogThread := TWatchCreateDialogThread.Create(True);
        DialogThread.FreeOnTerminate := True;
        DialogThread.BasehWnd  := hWnd;
        DialogThread.WatchStr  := 'IWiЂ쐬܂H';
        DialogThread.ButtonStr := '͂(&Y)';
        DialogThread.WaitTime  := 100;
        DialogThread.Resume;

        CompleteThread := TWatchCreateDialogThread.Create(True);
        CompleteThread.FreeOnTerminate := True;
        CompleteThread.BasehWnd  := hWnd;
        CompleteThread.WatchStr  := 'IWiЂ̍쐬ɏI܂B'#10#10'uPCɁvŁuXVv{^ƁA쐬Ђ'#10'\܂B';
        CompleteThread.ButtonStr := 'OK';
        CompleteThread.WaitTime  := 0;
        CompleteThread.Resume;

        PushButton(hWnd_Build);
      end;
    end;
  end;
  //
  DeleteTemporaryFiles;
  if Assigned(BuildPages) then BuildPages.Clear;
end;


// ------------------------------------------------------------------------------------

procedure TMangaSigmaForm.WMDropFiles(var Msg: TWMDropFiles);
var
  FileName: array[0..MAX_PATH] of Char;
  i, Count: Integer;
begin
  Count := DragQueryFile(Msg.Drop, $FFFFFFFF, nil, 0);
  for i := 0 to Count - 1 do
  begin
    DragQueryFile(Msg.Drop, i, FileName, SizeOf(FileName));
    AddItem(FileName);
  end;
  DragFinish(Msg.Drop);
end;


procedure TMangaSigmaForm.MainTimerTimer(Sender: TObject);
begin
  if (StartButton.Down) then
  begin
    ConvertFirstItem;
  end;
end;

procedure TMangaSigmaForm.FileListDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  fname,path: String;
begin
  with (Control as TListBox) do
  begin
    Canvas.FillRect(Rect);

    fname := Items[Index];
    path  := ExcludeTrailingPathDelimiter(ExtractFilePath(fname));
    path  := IncludeTrailingPathDelimiter(ExtractFileName(path));
    path  := path+ExtractFileName(fname);
    Canvas.TextOut(Rect.Left, Rect.Top, path);
  end;
end;

procedure TMangaSigmaForm.UpdateRemains;
begin
  RemainLabel.Caption := IntToStr(FileList.Items.Count)+'t@C';
end;

procedure TMangaSigmaForm.DeleteTemporaryFiles;
begin
  try
    if Assigned(DeleteFiles) then
    begin
      while (DeleteFiles.Count > 0) do
      begin
        DeleteFile(DeleteFiles.Strings[0]);
        DeleteFiles.Delete(0);
      end;
    end;
  finally
  end;
end;

procedure TMangaSigmaForm.FormDestroy(Sender: TObject);
var
  hWnd: Integer;
begin
  // Delete Temporary Files and Directory
  if Assigned(DeleteFiles) then
  begin
    DeleteTemporaryFiles;
    DeleteFiles.Free;
  end;
  if Assigned(BuildPages) then
  begin
    BuildPages.Free;
  end;
  if (OutputFolder <> '') then
  begin
    hWnd := FindWindow(nil,'BookBuilder');
    if (hWnd <> 0) then
    begin
      SendMessage(hWnd,WM_CLOSE,0,0);
      Sleep(1000);
    end;
    try
      RmDir(OutputFolder);
    finally
    end;
  end;
end;

end.


